/*  stdio.h	- standard i/o header add-on
 *
 *  ..for Lattice and Microsoft C and The Greenleaf Functions
 *    Copyright (C) 1983,1984 Greenleaf Software
 */

/* Note:  add defines for _LDATA and/or _LCODE here to determine
 * memory model.  S - None.  P - _LCODE.  D - _LDATA.  L - Both.
 */

#define EOS	'\0'    /* standard end of string       */

/* Additional Data and Function Types
*/
typedef unsigned int	word;
typedef char		byte;
typedef int		void;	/* no-return functions	*/
typedef int		bool;	/* boolean		*/

/*  Video and other system interrupts
*/
#define VIDEO  0x10	/* BIOS video interrupt 	*/
#define DOSINT 0x21	/* DOS Function Call interrupt	*/

/*  Structure used to pass registers to system interrupts (sysint)
*/
struct REGS { int ax,bx,cx,dx,si,di,ds,es; };

/*  Some useful words to use...
*/
#define YES	1
#define NO	0
#define TRUE	1
#define FALSE	0
#define OK	1
#define NOTOK	0
#define SUCCESS 1
#define FAILURE 0
#define ON	1
#define OFF	0
#define SET	1
#define CLEAR	0
#define FOREVER 1
#define NEVER	0
#define ERR	(-1)
#define ERROR	(-1)

/*  defines supporting IBM graphics printer functions and cursor
*/
#define NORM	1	/* normal graphics printer or plain-vanilla cursor */
#define FAST	2	/* fast (ESC Y) graphics print or fast blink cursr */
#define SLOW	3	/* slow blink cursor				   */
#define NOBLINK 4	/* non-blinking cursor				   */
#define INCHES	10	/* as in inches per page for form length	   */
#define LINES	11	/* ..lines per page..				   */

/*  general ASCII and related defines
*/
#define BLANK  0x20
#define CR	 13
#define LF	 10
#define FF	 12
#define BKSP	  8		/* BackSpace	*/
#define TAB	  9
#define ESC	 27		/*  ESCape	*/
#define DEL    0x7F		/*  Delete	*/

/*  video attributes (black/white)
*/
#define NORMAL	7
#define VNORMAL 7
#define REVERSE 0x70
#define NONDISP 0
#define BLINK	32	/* for video attributes or normal blink cursor	   */

/* used in some DOS functions to detect carry flag on return from SYSINT
*/
#define iscarry(x) ((x&0x0001)?TRUE:FALSE)

/*	end of standard header file add-on section.
*/

